



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>The Painter&#39;s Partition Problem Part I</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">The Painter&#39;s Partition Problem Part I</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-02 05:39:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>(http://leetcode.com/2011/04/the-painters-partition-problem.html)</p>
<p>You have to paint N boards of lenght {A0, A1, A2 ... AN-1}. There are K painters available and you are also given how much time a painter takes to paint 1 unit of board. You have to get this job done as soon as possible under the constraints that any painter will only paint continues sections of board, say board {2, 3, 4} or only board {1} or nothing but not board {2, 4, 5}.</p>
<p>We define M[n, k] as the optimum cost of a partition arrangement with <strong>n</strong> total blocks from the first block and <strong>k</strong> patitions, so</p>
<div>
<pre class="prettyprint linenums">                 n              n-1<br />M[n, k] = min { max { M[j, k-], <strong>&sum;</strong> Ai } }<br />
                j=1             i=j</pre>
</div>
<p>The base cases are:</p>
<div>
<pre class="prettyprint linenums">M[, k] = A0<br />
         n-1<br />
M[n, ] = <strong>&Sigma;</strong> Ai<br />         i=0</pre>
</div>
<p>Therefore, the brute force solution is:</p>
<div>
<pre class="prettyprint linenums">int sum(int A[], int from, int to)<br />
{<br />
    int total = ;<br />
    for (int i = from; i &lt;= to; i++)<br />
        total += A[i];<br />
    return total;<br />
}

int partition(int A[], int n, int k)<br />
{<br />
    if (n &lt;=  || k &lt;= )<br />
        return -;<br />
    if (n == )<br />
        return A[];<br />
    if (k == )<br />
        return sum(A, , n-);

    int best = INT_MAX;<br />
    for (int j = ; j &lt;= n; j++)<br />
        best = min(best, max(partition(A, j, k-), sum(A, j, n-)));

    return best;<br />
}</pre>
</div>
<p>It is exponential in run time complexity due to re-computation of the same values over and over again.</p>
<p>The DP solution:</p>
<div>
<pre class="prettyprint linenums">int findMax(int A[], int n, int k)<br />
{<br />
    int M[n+][k+];<br />
    int sum[n+];<br />
    for (int i = ; i &lt;= n; i++)<br />
        sum[i] = sum[i-] + A[i-];

    for (int i = ; i &lt;= n; i++)<br />
        M[i][] = sum[i];<br />
    for (int i = ; i &lt;= k; i++)<br />
        M[][k] = A[];

    for (int i = ; i &lt;= k; i++)<br />
    {<br />
        for (int j = ; j &lt;= n; j++)<br />
        {<br />
            int best = INT_MAX;<br />
            for (int p = ; p &lt;= j; p++)<br />
            {<br />
                best = min(best, max(M[p][i-], sum[j]-sum[p]));<br />
            }<br />
            M[j][i] = best;<br />
        }<br />
    }<br />
    return M[n][k];<br />
}</pre>
</div>
<p>Run time: O(kN*N), space complexity: O(kN).</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxkwnj8.html">c语言经典算法&mdash;&mdash;查找一个整数数组中第二大数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9ppv6z9.html">hadoop从非HA转到NAMENODE HA时需要注意的一个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mlnyp9.html">linux 源码安装详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e5ozm8.html">使用MaskFilter</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv0lxj8.html">iframe  简单的一个用法 局部调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j24vw8.html">ping脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnd2gd8.html">Struts2 - Study 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm5pp19.html">C之文件读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xkpwr9.html">php 中奖概率算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03oe0q.html">Python新手学习基础之运算符&mdash;&mdash;赋值与逻辑运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdo2l48.html">MariaDB忘记root密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mewxw0q.html">wiringPi安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexxn6q.html">JDK 1&period;8 源码阅读和理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd534y9.html">all unicode</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo07p1q.html">docker-maven-plugin插件设置Docker的buildArgs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2m6wj9.html">POJ 2594 Treasure Exploration（最小可相交路径覆盖）题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpgwp79.html">java对象流与序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp0mm09.html">Linux kernel模块管理相关详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77mxv1q.html">数据存储－－ Core Data的使用（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlol2jkq.html">MySQL聚合函数在计算时，不会自动匹配与之相对应的数据</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96o6pnj9.html">&lbrack;Leetcode&rsqb;&lbrack;Python&rsqb;20&colon; Valid Parentheses</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o6p1y9.html">openNebula rgister img instance vms error collections</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okx1pe9.html">MySql数据库连接池</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde6j0x9.html">cocos2d-x获取系统时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vw2vm8.html">mongodb cpu 超过100&percnt;居高不下的原因分析过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnoj3pq.html">IOS开发环境更换后重新制作Provisioning Profile证书详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x5dx08.html">Hibernate学习之Hibernate流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o6drv9.html">hadoop搭建杂记：Linux下hostname的更改办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyde6jgq.html">android双击返回键退出程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w7yvoq.html">Python2&period;7&period;3 学习&mdash;&mdash;准备开发环境</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
